SystemOrganization addCategory: #WaffleLayout!

Object subclass: #WFSegment
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

WFSegment subclass: #WFFixedSegment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFFixedSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:45'!
length

	^self number! !

!WFFixedSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:57'!
lengthIsFixed

	^true! !

!WFFixedSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:03'!
lengthIsProportional

	^false! !

WFSegment subclass: #WFProportionalSegment
	instanceVariableNames: 'waffleSide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 12:02'!
defaultWaffleSide

	|side|
	side :=  WFWaffleSide new.
	side addSegment: self.    
	^side! !

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:12'!
length
	^ self proportion * self waffleSide absoluteLengthPerProportion! !

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:03'!
lengthIsProportional
	^true! !

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:47'!
proportion

	^self number! !

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:48'!
waffleSide

	^waffleSide setDefault: #defaultWaffleSide for: self withSetter: #waffleSide:! !

!WFProportionalSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:49'!
waffleSide: aWFWaffleSide 

	waffleSide := aWFWaffleSide! !

!WFSegment classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 09:21'!
number: aNumber

	^self new number: aNumber! !

!WFSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:44'!
defaultNumber

	^1! !

!WFSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:58'!
lengthIsFixed

	^false! !

!WFSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:43'!
number

	^number setDefault: #defaultNumber for: self  withSetter: #number:! !

!WFSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 07:43'!
number: aNumber

	number := aNumber! !

!WFSegment methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 08:00'!
waffleSide: aWFWaffleSide 
! !

Object subclass: #WFWaffleLayout
	instanceVariableNames: 'columnSegments rowSegments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFWaffleLayout methodsFor: 'adding segment' stamp: 'hjo 11/28/2011 12:02'!
addColumnSegment: aWFSegment 

	self columnSegments addSegment: aWFSegment! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'hjo 11/28/2011 11:49'!
addFixedColumnSegment: aNumber 

	self addColumnSegment: (WFFixedSegment number: aNumber).! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'hjo 11/28/2011 11:53'!
addFixedRowSegment: aNumber

	self addRowSegment: (WFFixedSegment number: aNumber).! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'hjo 11/28/2011 11:54'!
addProportionalColumnSegment: aNumber 

	self addColumnSegment: (WFProportionalSegment number: aNumber)! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'hjo 11/28/2011 11:54'!
addProportionalRowSegment: aNumber 

	self addRowSegment: (WFProportionalSegment number: aNumber).! !

!WFWaffleLayout methodsFor: 'adding segment' stamp: 'hjo 11/28/2011 12:02'!
addRowSegment: aWFSegment 

	self rowSegments addSegment: aWFSegment  ! !

!WFWaffleLayout methodsFor: 'adding conviently' stamp: 'hjo 11/28/2011 12:56'!
addRows: numberOfRowsToAdd addColumns: numberOfColumnsToAdd fixedGap: gapLength 

	self rowSegments addProportionalSegments: numberOfRowsToAdd fixedGap: gapLength.
	self columnSegments addProportionalSegments: numberOfColumnsToAdd fixedGap: gapLength.! !

!WFWaffleLayout methodsFor: 'bounds' stamp: 'hjo 11/28/2011 11:58'!
bounds

	^self privateGetBoundsFromXRange: (self columnSegments range) yRange:  (self rowSegments range)! !

!WFWaffleLayout methodsFor: 'bounds' stamp: 'hjo 11/28/2011 11:58'!
bounds: aRectangle 

	self rowSegments range: (Range close: aRectangle top open: aRectangle bottom).
	self columnSegments range: (Range close: aRectangle left open: aRectangle right).! !

!WFWaffleLayout methodsFor: 'bounds' stamp: 'hjo 11/28/2011 11:58'!
boundsOfIndentationAtRow: integer1 atColumn: integer2 

	|xRange yRange|
	xRange := self columnSegments rangeOfIndentationAtIndex: integer2.
	yRange := self rowSegments rangeOfIndentationAtIndex: integer1.
	^self privateGetBoundsFromXRange: xRange yRange:  yRange.! !

!WFWaffleLayout methodsFor: 'accessing' stamp: 'hjo 11/28/2011 12:13'!
columnSegments

	^ columnSegments setDefault: #defaultSegments for: self  withSetter:  #columnSegments:! !

!WFWaffleLayout methodsFor: 'accessing' stamp: 'hjo 11/28/2011 12:10'!
columnSegments: aWFWaffleSide 

	columnSegments := aWFWaffleSide! !

!WFWaffleLayout methodsFor: 'accessing' stamp: 'hjo 11/28/2011 12:12'!
defaultSegments

	^WFWaffleSide new! !

!WFWaffleLayout methodsFor: 'morphic' stamp: 'hjo 11/28/2011 13:41'!
placeMorph: aMorph atRow: integer1 atColumn: integer2
	
	aMorph bounds: (self boundsOfIndentationAtRow: integer1 atColumn: integer2).! !

!WFWaffleLayout methodsFor: 'bounds' stamp: 'hjo 11/28/2011 10:53'!
privateGetBoundsFromXRange: range1 yRange: range2

	^(range1 start @ range2 start) corner: (range1 stop @ range2 stop)! !

!WFWaffleLayout methodsFor: 'accessing' stamp: 'hjo 11/28/2011 12:13'!
rowSegments

	^ rowSegments setDefault: #defaultSegments for: self withSetter: #rowSegments:! !

!WFWaffleLayout methodsFor: 'accessing' stamp: 'hjo 11/28/2011 12:11'!
rowSegments: aWFWaffleSide 

	rowSegments := aWFWaffleSide! !

Object subclass: #WFWaffleSide
	instanceVariableNames: 'range absoluteLengthPerProportion segments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WaffleLayout'!

!WFWaffleSide classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/28/2011 13:50'!
example1

	| mainMorph waffle subs |
	mainMorph := RectangleMorph new.
	mainMorph extent: 400@300.

	waffle := WFWaffleLayout new.
	waffle bounds: mainMorph bounds.
	waffle addRows: 3 addColumns: 2 fixedGap: 5.

	subs := Matrix rows: 3 columns: 2.

	1 to: 3 do: [:r|
		1 to: 2 do: [:c| |sub|
			sub := RectangleMorph new.
			mainMorph addMorph: sub.
			subs at: r at: c put: sub. 
			]
		].

	"You can repeat code below whenever the mainMorph's extent is changed."
	waffle bounds: mainMorph bounds.
	subs withIndicesDo: [:sub :r :c| 
		waffle placeMorph: sub atRow: r atColumn: c.].! !

!WFWaffleSide methodsFor: 'computing' stamp: 'hjo 11/28/2011 08:15'!
absoluteLengthPerProportion

	^absoluteLengthPerProportion setDefault: #defaultAbsoluteLengthPerProportion for: self withSetter: #absoluteLengthPerProportion:! !

!WFWaffleSide methodsFor: 'computing' stamp: 'hjo 11/28/2011 08:15'!
absoluteLengthPerProportion: aFloat 

	absoluteLengthPerProportion := aFloat! !

!WFWaffleSide methodsFor: 'adding segments' stamp: 'hjo 11/28/2011 12:54'!
addProportionalSegments: anInteger fixedGap: gapLength

	| addGap |
	addGap := [self addSegment: (WFFixedSegment number: gapLength)].
	addGap value.
	anInteger timesRepeat: [
			self addSegment: (WFProportionalSegment number: 1).
			addGap value]. ! !

!WFWaffleSide methodsFor: 'adding segments' stamp: 'hjo 11/28/2011 12:19'!
addSegment: aWFSegment 
	
	self absoluteLengthPerProportion: nil.
	self segments addLast: aWFSegment.
	aWFSegment waffleSide: self.  ! !

!WFWaffleSide methodsFor: 'computing' stamp: 'hjo 11/28/2011 12:20'!
defaultAbsoluteLengthPerProportion
	
	^self lengthThatProportionalSegmentsMayDivide / self sumOfProportions! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'hjo 11/28/2011 07:51'!
defaultRange

	^Range close: 0 open: 100! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:01'!
defaultSegments

	^OrderedCollection new! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:05'!
fixedSegments

	^self segments select: #lengthIsFixed! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'hjo 11/28/2011 07:50'!
length

	^self range span! !

!WFWaffleSide methodsFor: 'computing' stamp: 'hjo 11/28/2011 12:20'!
lengthThatProportionalSegmentsMayDivide

	| result |
	result := self length - self sumOfLengthOfFixedSegments.
	self assert: [result >= 0].  
	^result! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:06'!
proportionalSegments

	^self segments select: #lengthIsProportional! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'hjo 11/28/2011 07:51'!
range

	^range setDefault: #defaultRange for: self withSetter: #range:! !

!WFWaffleSide methodsFor: 'accessing' stamp: 'hjo 11/28/2011 08:15'!
range: aRange 

	self absoluteLengthPerProportion: nil.
	range := aRange! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:38'!
rangeOfIndentationAtIndex: anInteger
	| rangeStart segmentIndexOfIndentation |
	segmentIndexOfIndentation := anInteger * 2.
	self assert: [ self segments size >= 3 ] description: 'not enough segments'.
	rangeStart := self range start + (self sumOfLengthOfHeadingSegmentsUpTo: segmentIndexOfIndentation).
	^ Range close: rangeStart open: rangeStart + (self segments at: segmentIndexOfIndentation) length! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:05'!
segmentOfIndentationAtIndex: anInteger 

	^self segments at: anInteger * 2! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:12'!
segments

	^ segments setDefault: #defaultSegments for: self withSetter: #segments:! !

!WFWaffleSide methodsFor: 'segments' stamp: 'hjo 11/28/2011 12:12'!
segments: anOrderedCollection 

	segments := anOrderedCollection! !

!WFWaffleSide methodsFor: 'sum' stamp: 'hjo 11/28/2011 12:07'!
sumOfLengthOfFixedSegments
	
	| f |
	f := self fixedSegments collect: #length.
	^f isEmpty ifTrue: [0] ifFalse: [f sum].! !

!WFWaffleSide methodsFor: 'sum' stamp: 'hjo 11/28/2011 12:38'!
sumOfLengthOfHeadingSegmentsUpTo: anInteger
	^ ((self segments copyFrom: 1 to: anInteger - 1) collect: #length) sum! !

!WFWaffleSide methodsFor: 'sum' stamp: 'hjo 11/28/2011 12:06'!
sumOfProportions

	^(self proportionalSegments collect: #proportion) sum! !
